// shopbot.h ackmed@gotwalls.com
#pragma once
#include "item.h"
#include "config.h"
#include "external/D2Hackit.h"
#include "external/D2Client.h"

// defines
#define VERSION_MAJOR		0
#define VERSION_MINOR		46

#define DEBUG_OFF			0x00
#define DEBUG_USER			0x01
#define	DEBUG_DEVEL			0x02
#define DEBUG_PACKET		0x03

// different states the bot can be in
#define STATE_NONE			0x00	// bot not going
#define STATE_ANTIIDLE		0x01	// anti idle mode.

#define	STATE_WALKNPC_START	0x02
#define STATE_WALKNPC		0x03
#define STATE_WALKWP_START	0x04
#define STATE_WALKWP		0x05

#define STATE_OPENSTORE		0x06
#define STATE_CLOSESTORE	0x07

#define STATE_WPTOTOWN		0x08	// taking wp to town
#define STATE_WPFROMTOWN	0x09	// taking wp to loc out of town




// global vars
extern WORD Debug;
extern char DebugBuffer[1024];
extern WORD state;

// functions
BOOL PRIVATE OnCommandDebug(char **argv, int argc);
BOOL PRIVATE OnCommandRecord(char **argv, int argc);
BOOL PRIVATE OnCommandClear(char **argv, int argc);
BOOL PRIVATE OnCommandSetNPC(char **argv, int argc);
BOOL PRIVATE OnCommandHelp(char** argv, int argc);
BOOL PRIVATE OnCommandReload(char **argv, int argc);
BOOL PRIVATE OnCommandStart(char **argv, int argc);
BOOL PRIVATE OnCommandStop(char **argv, int argc);
BOOL PRIVATE OnCommandSavePath(char **argv, int argc);
BOOL PRIVATE OnCommandLoadPath(char **argv, int argc);
BOOL PRIVATE OnCommandTownWP(char **argv, int argc);
BOOL PRIVATE OnCommandOtherWP(char **argv, int argc);

BOOL LoadConfig(void);
CONFIGSTRUCT* ItemMatchCheck(ITEMSTRUCT *item);
void SetNPCLid(int actNum, char *npcName);
void ListNPC(int actNum);

